package priusfan.info.btion45;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "priusfan.info.btion45", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "priusfan.info.btion45", "main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _dbfilepath = "";
public static String _dbfilename = "";
public static anywheresoftware.b4a.sql.SQL _sql1 = null;
public static String _bt_macadr = "";
public static int _fps = 0;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _admin = null;
public static anywheresoftware.b4a.gps.GPS _gps1 = null;
public static anywheresoftware.b4a.phone.Phone.PhoneWakeState _phone2 = null;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public static anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
public static long _datheur = 0L;
public anywheresoftware.b4a.objects.ButtonWrapper _btn_connect = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn_stop = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_connect = null;
public static int _i = 0;
public static int _j = 0;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_fps = null;
public static double _whkm = 0;
public anywheresoftware.b4a.objects.LabelWrapper _l_a = null;
public anywheresoftware.b4a.objects.LabelWrapper _l_auto = null;
public anywheresoftware.b4a.objects.LabelWrapper _l_odo = null;
public anywheresoftware.b4a.objects.LabelWrapper _l_speed = null;
public anywheresoftware.b4a.objects.LabelWrapper _l_v = null;
public anywheresoftware.b4a.objects.LabelWrapper _l_w = null;
public anywheresoftware.b4a.objects.LabelWrapper _lg_alt = null;
public anywheresoftware.b4a.objects.LabelWrapper _lg_lat = null;
public anywheresoftware.b4a.objects.LabelWrapper _lg_lon = null;
public anywheresoftware.b4a.objects.LabelWrapper _lg_speed = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnl_gps = null;
public anywheresoftware.b4a.objects.LabelWrapper _l_whkm = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnl_graph = null;
public static int _ctro = 0;
public static int[] _todo = null;
public static int[] _twpos = null;
public static int[] _twneg = null;
public anywheresoftware.b4a.objects.LabelWrapper _l_soc = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnl_trip = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_avgspeed = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_dist = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_time = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_whi = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_whkm = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_who = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_pc = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl_cor = null;
public anywheresoftware.b4a.objects.LabelWrapper _lalt = null;
public static boolean _toggle_alt = false;
public scanner _scanner = null;
public charts _charts = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
String _crttabodo = "";
String _crtindodo = "";
String _crttabsec = "";
String _crttabmac = "";
anywheresoftware.b4a.sql.SQL.CursorWrapper _cur = null;
 //BA.debugLineNum = 77;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 78;BA.debugLine="File.MakeDir(File.DirRootExternal, \"BT_CAN\")";
anywheresoftware.b4a.keywords.Common.File.MakeDir(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"BT_CAN");
 //BA.debugLineNum = 79;BA.debugLine="If File.Exists(DBFilePath, DBFileName) = False Then";
if (anywheresoftware.b4a.keywords.Common.File.Exists(_dbfilepath,_dbfilename)==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 80;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 81;BA.debugLine="Dim crttabodo As String 	: crttabodo = \"CREATE TABLE ODOLOG (TIMESTAMP INT, ODO INT,B_SOC REAL, KM_NBS INT, WHPOS INT, WHNEG INT,RR INT, GPS_LAT TEXT,GPS_LON TEXT, GPS_SPEED REAL,GPS_ALT REAL,BARO INT ,PRIMARY KEY (ODO)) \"";
_crttabodo = "";
 //BA.debugLineNum = 81;BA.debugLine="Dim crttabodo As String 	: crttabodo = \"CREATE TABLE ODOLOG (TIMESTAMP INT, ODO INT,B_SOC REAL, KM_NBS INT, WHPOS INT, WHNEG INT,RR INT, GPS_LAT TEXT,GPS_LON TEXT, GPS_SPEED REAL,GPS_ALT REAL,BARO INT ,PRIMARY KEY (ODO)) \"";
_crttabodo = "CREATE TABLE ODOLOG (TIMESTAMP INT, ODO INT,B_SOC REAL, KM_NBS INT, WHPOS INT, WHNEG INT,RR INT, GPS_LAT TEXT,GPS_LON TEXT, GPS_SPEED REAL,GPS_ALT REAL,BARO INT ,PRIMARY KEY (ODO)) ";
 //BA.debugLineNum = 82;BA.debugLine="Dim crtindodo As String 	: crtindodo = \"CREATE INDEX ODOLOG_L1 ON ODOLOG (ODO DESC) \"";
_crtindodo = "";
 //BA.debugLineNum = 82;BA.debugLine="Dim crtindodo As String 	: crtindodo = \"CREATE INDEX ODOLOG_L1 ON ODOLOG (ODO DESC) \"";
_crtindodo = "CREATE INDEX ODOLOG_L1 ON ODOLOG (ODO DESC) ";
 //BA.debugLineNum = 83;BA.debugLine="Dim CRTTABSEC As String 	: CRTTABSEC = \"CREATE TABLE SECLOG (TIMESTAMP INT, FPS INT,ODO INT,SPEED REAL,B_VOLT REAL,B_AMP REAL,B_SOC REAL,RR INT, GPS_LAT TEXT,GPS_LON TEXT, GPS_SPEED REAL,GPS_ALT REAL,BARO INT ,PRIMARY KEY (TIMESTAMP)) \"";
_crttabsec = "";
 //BA.debugLineNum = 83;BA.debugLine="Dim CRTTABSEC As String 	: CRTTABSEC = \"CREATE TABLE SECLOG (TIMESTAMP INT, FPS INT,ODO INT,SPEED REAL,B_VOLT REAL,B_AMP REAL,B_SOC REAL,RR INT, GPS_LAT TEXT,GPS_LON TEXT, GPS_SPEED REAL,GPS_ALT REAL,BARO INT ,PRIMARY KEY (TIMESTAMP)) \"";
_crttabsec = "CREATE TABLE SECLOG (TIMESTAMP INT, FPS INT,ODO INT,SPEED REAL,B_VOLT REAL,B_AMP REAL,B_SOC REAL,RR INT, GPS_LAT TEXT,GPS_LON TEXT, GPS_SPEED REAL,GPS_ALT REAL,BARO INT ,PRIMARY KEY (TIMESTAMP)) ";
 //BA.debugLineNum = 84;BA.debugLine="Dim CRTTABMAC As String 	: CRTTABMAC = \"CREATE TABLE MACADR (BT_Macadr TEXT) \"";
_crttabmac = "";
 //BA.debugLineNum = 84;BA.debugLine="Dim CRTTABMAC As String 	: CRTTABMAC = \"CREATE TABLE MACADR (BT_Macadr TEXT) \"";
_crttabmac = "CREATE TABLE MACADR (BT_Macadr TEXT) ";
 //BA.debugLineNum = 86;BA.debugLine="SQL1.Initialize(DBFilePath, DBFileName, True)";
_sql1.Initialize(_dbfilepath,_dbfilename,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 87;BA.debugLine="SQL1.ExecNonQuery(crttabodo)";
_sql1.ExecNonQuery(_crttabodo);
 //BA.debugLineNum = 88;BA.debugLine="SQL1.ExecNonQuery(crtindodo)";
_sql1.ExecNonQuery(_crtindodo);
 //BA.debugLineNum = 89;BA.debugLine="SQL1.ExecNonQuery(CRTTABSEC)";
_sql1.ExecNonQuery(_crttabsec);
 //BA.debugLineNum = 90;BA.debugLine="SQL1.ExecNonQuery(CRTTABMAC)";
_sql1.ExecNonQuery(_crttabmac);
 };
 }else {
 //BA.debugLineNum = 93;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 94;BA.debugLine="SQL1.Initialize(DBFilePath, DBFileName, True)";
_sql1.Initialize(_dbfilepath,_dbfilename,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 96;BA.debugLine="Dim Cur As Cursor";
_cur = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 //BA.debugLineNum = 97;BA.debugLine="BT_Macadr = \" \"";
_bt_macadr = " ";
 //BA.debugLineNum = 98;BA.debugLine="Cur = SQL1.ExecQuery(\"SELECT BT_Macadr FROM MACADR \")";
_cur.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT BT_Macadr FROM MACADR ")));
 //BA.debugLineNum = 99;BA.debugLine="If Cur.RowCount > 0 Then";
if (_cur.getRowCount()>0) { 
 //BA.debugLineNum = 100;BA.debugLine="Cur.Position = 0";
_cur.setPosition((int)(0));
 //BA.debugLineNum = 101;BA.debugLine="BT_Macadr = Cur.GetString2(0)";
_bt_macadr = _cur.GetString2((int)(0));
 };
 //BA.debugLineNum = 103;BA.debugLine="Cur.Close";
_cur.Close();
 };
 };
 //BA.debugLineNum = 107;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 108;BA.debugLine="GPS1.Initialize(\"GPS\")";
_gps1.Initialize("GPS");
 //BA.debugLineNum = 109;BA.debugLine="If GPS1.GPSEnabled = False Then StartActivity (GPS1.LocationSettingsIntent)";
if (_gps1.getGPSEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(_gps1.getLocationSettingsIntent()));};
 //BA.debugLineNum = 110;BA.debugLine="Admin.Initialize(\"admin\")";
_admin.Initialize(processBA,"admin");
 //BA.debugLineNum = 116;BA.debugLine="Serial1.Initialize(\"Serial1\")";
_serial1.Initialize("Serial1");
 //BA.debugLineNum = 117;BA.debugLine="If Serial1.IsEnabled = False Then";
if (_serial1.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 118;BA.debugLine="Msgbox(\"Please enable Bluetooth.\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Please enable Bluetooth.","",mostCurrent.activityBA);
 }else {
 //BA.debugLineNum = 121;BA.debugLine="If BT_Macadr.Length = 17 Then";
if (_bt_macadr.length()==17) { 
 //BA.debugLineNum = 122;BA.debugLine="Serial1.Connect(BT_Macadr)";
_serial1.Connect(processBA,_bt_macadr);
 }else {
 //BA.debugLineNum = 124;BA.debugLine="Btn_connect_Click";
_btn_connect_click();
 };
 };
 };
 //BA.debugLineNum = 128;BA.debugLine="toggle_alt=False";
_toggle_alt = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 129;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 164;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 165;BA.debugLine="Phone2.ReleaseKeepAlive";
_phone2.ReleaseKeepAlive();
 //BA.debugLineNum = 166;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
anywheresoftware.b4a.sql.SQL.CursorWrapper _cur = null;
 //BA.debugLineNum = 131;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 133;BA.debugLine="If Admin.IsEnabled = False Then";
if (_admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 134;BA.debugLine="If Admin.Enable = False Then";
if (_admin.Enable()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 135;BA.debugLine="ToastMessageShow(\"Error enabling Bluetooth adapter.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error enabling Bluetooth adapter.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 137;BA.debugLine="ToastMessageShow(\"Enabling Bluetooth adapter...\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Enabling Bluetooth adapter...",anywheresoftware.b4a.keywords.Common.False);
 };
 };
 //BA.debugLineNum = 141;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 142;BA.debugLine="Phone2.KeepAlive(True)";
_phone2.KeepAlive(processBA,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 143;BA.debugLine="Pnl_trip.Visible=False";
mostCurrent._pnl_trip.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 144;BA.debugLine="Pnl_trip.Enabled=False";
mostCurrent._pnl_trip.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 145;BA.debugLine="ShowConnectSts";
_showconnectsts();
 //BA.debugLineNum = 147;BA.debugLine="Dim cur As Cursor";
_cur = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 //BA.debugLineNum = 148;BA.debugLine="cur = SQL1.ExecQuery(\"SELECT odo,whpos,whneg FROM ODOLOG order by odo desc limit 10 \")";
_cur.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT odo,whpos,whneg FROM ODOLOG order by odo desc limit 10 ")));
 //BA.debugLineNum = 149;BA.debugLine="ctro = 0";
_ctro = (int)(0);
 //BA.debugLineNum = 150;BA.debugLine="If cur.RowCount > 0 Then";
if (_cur.getRowCount()>0) { 
 //BA.debugLineNum = 151;BA.debugLine="For i=cur.RowCount-1 To 0 Step -1";
{
final double step118 = -1;
final double limit118 = (int)(0);
for (_i = (int)(_cur.getRowCount()-1); (step118 > 0 && _i <= limit118) || (step118 < 0 && _i >= limit118); _i += step118) {
 //BA.debugLineNum = 152;BA.debugLine="cur.Position = i";
_cur.setPosition(_i);
 //BA.debugLineNum = 153;BA.debugLine="ctro = ctro + 1";
_ctro = (int)(_ctro+1);
 //BA.debugLineNum = 154;BA.debugLine="todo(ctro) = cur.GetInt2(0)";
_todo[_ctro] = _cur.GetInt2((int)(0));
 //BA.debugLineNum = 155;BA.debugLine="twpos(ctro) = cur.GetInt2(1) * - 1";
_twpos[_ctro] = (int)(_cur.GetInt2((int)(1))*-1);
 //BA.debugLineNum = 156;BA.debugLine="twneg(ctro) = cur.GetInt2(2) * - 1";
_twneg[_ctro] = (int)(_cur.GetInt2((int)(2))*-1);
 }
};
 };
 //BA.debugLineNum = 159;BA.debugLine="cur.Close";
_cur.Close();
 //BA.debugLineNum = 161;BA.debugLine="RefreshOdo";
_refreshodo();
 //BA.debugLineNum = 162;BA.debugLine="End Sub";
return "";
}
public static String  _btn_connect_click() throws Exception{
anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _res = 0;
 //BA.debugLineNum = 168;BA.debugLine="Sub Btn_connect_Click";
 //BA.debugLineNum = 169;BA.debugLine="Dim PairedDevices As Map";
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 170;BA.debugLine="PairedDevices = Serial1.GetPairedDevices";
_paireddevices = _serial1.GetPairedDevices();
 //BA.debugLineNum = 171;BA.debugLine="Dim l As List";
_l = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 172;BA.debugLine="l.Initialize";
_l.Initialize();
 //BA.debugLineNum = 173;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
{
final double step137 = 1;
final double limit137 = (int)(_paireddevices.getSize()-1);
for (_i = (int)(0); (step137 > 0 && _i <= limit137) || (step137 < 0 && _i >= limit137); _i += step137) {
 //BA.debugLineNum = 174;BA.debugLine="l.Add(PairedDevices.GetKeyAt(i))";
_l.Add(_paireddevices.GetKeyAt(_i));
 }
};
 //BA.debugLineNum = 176;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 177;BA.debugLine="res = InputList(l, \"Choose device\", - 1) 'show list with paired devices";
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Choose device",(int)(-1),mostCurrent.activityBA);
 //BA.debugLineNum = 178;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 //BA.debugLineNum = 179;BA.debugLine="BT_Macadr = PairedDevices.Get(l.Get(res))				'convert the name to mac address";
_bt_macadr = String.valueOf(_paireddevices.Get(_l.Get(_res)));
 //BA.debugLineNum = 180;BA.debugLine="Serial1.Connect(BT_Macadr)";
_serial1.Connect(processBA,_bt_macadr);
 };
 //BA.debugLineNum = 182;BA.debugLine="End Sub";
return "";
}
public static String  _btn_stop_click() throws Exception{
 //BA.debugLineNum = 202;BA.debugLine="Sub Btn_stop_Click";
 //BA.debugLineNum = 203;BA.debugLine="StopService(scanner) ' kill service";
anywheresoftware.b4a.keywords.Common.StopService(mostCurrent.activityBA,(Object)(mostCurrent._scanner.getObject()));
 //BA.debugLineNum = 204;BA.debugLine="exp_table(\"seclog\")";
_exp_table("seclog");
 //BA.debugLineNum = 205;BA.debugLine="exp_table(\"odolog\")";
_exp_table("odolog");
 //BA.debugLineNum = 206;BA.debugLine="SQL1.Close";
_sql1.Close();
 //BA.debugLineNum = 207;BA.debugLine="Phone2.ReleaseKeepAlive";
_phone2.ReleaseKeepAlive();
 //BA.debugLineNum = 208;BA.debugLine="Activity_Pause(True) 'let the program save its state";
_activity_pause(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 209;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 //BA.debugLineNum = 211;BA.debugLine="End Sub";
return "";
}
public static String  _converttotimeformat(long _sec) throws Exception{
int _seconds = 0;
int _minutes = 0;
int _hours = 0;
 //BA.debugLineNum = 322;BA.debugLine="Sub ConvertToTimeFormat(sec As Long) As String";
 //BA.debugLineNum = 323;BA.debugLine="Dim seconds, minutes, hours As Int";
_seconds = 0;
_minutes = 0;
_hours = 0;
 //BA.debugLineNum = 324;BA.debugLine="seconds = sec";
_seconds = (int)(_sec);
 //BA.debugLineNum = 325;BA.debugLine="minutes = Floor(seconds / 60) Mod 60";
_minutes = (int)(anywheresoftware.b4a.keywords.Common.Floor(_seconds/(double)60)%60);
 //BA.debugLineNum = 326;BA.debugLine="hours = Floor(seconds / 3600)";
_hours = (int)(anywheresoftware.b4a.keywords.Common.Floor(_seconds/(double)3600));
 //BA.debugLineNum = 327;BA.debugLine="seconds = seconds Mod 60";
_seconds = (int)(_seconds%60);
 //BA.debugLineNum = 328;BA.debugLine="Return NumberFormat(hours, 1, 0) & \":\" & NumberFormat(minutes, 2, 0) & \":\" & NumberFormat(seconds, 2, 0)";
if (true) return anywheresoftware.b4a.keywords.Common.NumberFormat(_hours,(int)(1),(int)(0))+":"+anywheresoftware.b4a.keywords.Common.NumberFormat(_minutes,(int)(2),(int)(0))+":"+anywheresoftware.b4a.keywords.Common.NumberFormat(_seconds,(int)(2),(int)(0));
 //BA.debugLineNum = 329;BA.debugLine="End Sub";
return "";
}
public static String  _createstackedbarstab() throws Exception{
charts._bardata _bd = null;
charts._graph _g = null;
 //BA.debugLineNum = 299;BA.debugLine="Sub CreateStackedBarsTab";
 //BA.debugLineNum = 300;BA.debugLine="Dim BD As BarData";
_bd = new charts._bardata();
 //BA.debugLineNum = 301;BA.debugLine="BD.Initialize";
_bd.Initialize();
 //BA.debugLineNum = 302;BA.debugLine="BD.Target = Pnl_graph";
_bd.Target = mostCurrent._pnl_graph;
 //BA.debugLineNum = 303;BA.debugLine="BD.BarsWidth = Pnl_graph.Width/(ctro + 1)";
_bd.BarsWidth = (int)(mostCurrent._pnl_graph.getWidth()/(double)(_ctro+1));
 //BA.debugLineNum = 304;BA.debugLine="BD.Stacked = True 'Makes it a stacked bars chart";
_bd.Stacked = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 305;BA.debugLine="Charts.AddBarColor(BD, MakeTransparent(Colors.Yellow, 230)) 'First bar color";
mostCurrent._charts._addbarcolor(mostCurrent.activityBA,_bd,_maketransparent(anywheresoftware.b4a.keywords.Common.Colors.Yellow,(int)(230)));
 //BA.debugLineNum = 306;BA.debugLine="Charts.AddBarColor(BD, MakeTransparent(Colors.Green, 230))";
mostCurrent._charts._addbarcolor(mostCurrent.activityBA,_bd,_maketransparent(anywheresoftware.b4a.keywords.Common.Colors.Green,(int)(230)));
 //BA.debugLineNum = 307;BA.debugLine="For i = 1 To ctro";
{
final double step248 = 1;
final double limit248 = _ctro;
for (_i = (int)(1); (step248 > 0 && _i <= limit248) || (step248 < 0 && _i >= limit248); _i += step248) {
 //BA.debugLineNum = 308;BA.debugLine="Charts.AddBarPoint(BD, todo(i), Array As Float(twneg(i), twpos(i)))";
mostCurrent._charts._addbarpoint(mostCurrent.activityBA,_bd,BA.NumberToString(_todo[_i]),new float[]{(float)(_twneg[_i]),(float)(_twpos[_i])});
 }
};
 //BA.debugLineNum = 310;BA.debugLine="Dim G As Graph";
_g = new charts._graph();
 //BA.debugLineNum = 311;BA.debugLine="G.Initialize";
_g.Initialize();
 //BA.debugLineNum = 312;BA.debugLine="G.Title = \"Modèle Visu Histo iOn\"";
_g.Title = "Modèle Visu Histo iOn";
 //BA.debugLineNum = 313;BA.debugLine="G.XAxis = \"kM\"";
_g.XAxis = "kM";
 //BA.debugLineNum = 314;BA.debugLine="G.YAxis = \"WH/kM\"";
_g.YAxis = "WH/kM";
 //BA.debugLineNum = 315;BA.debugLine="G.YStart = 0";
_g.YStart = (float)(0);
 //BA.debugLineNum = 316;BA.debugLine="G.YEnd = 250";
_g.YEnd = (float)(250);
 //BA.debugLineNum = 317;BA.debugLine="G.YInterval = 50";
_g.YInterval = (float)(50);
 //BA.debugLineNum = 318;BA.debugLine="G.AxisColor = Colors.White";
_g.AxisColor = anywheresoftware.b4a.keywords.Common.Colors.White;
 //BA.debugLineNum = 319;BA.debugLine="Charts.DrawBarsChart(G, BD, Colors.Black)";
mostCurrent._charts._drawbarschart(mostCurrent.activityBA,_g,_bd,anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 320;BA.debugLine="End Sub";
return "";
}
public static String  _exp_table(String _table) throws Exception{
anywheresoftware.b4a.sql.SQL.CursorWrapper _cur = null;
int _col_e = 0;
int _row = 0;
anywheresoftware.b4a.keywords.StringBuilderWrapper _bigtxt = null;
int _limit = 0;
String _today = "";
long _ts = 0L;
long _date1 = 0L;
long _date2 = 0L;
String _clause = "";
String[] _values = null;
 //BA.debugLineNum = 336;BA.debugLine="Sub exp_table(table As String)";
 //BA.debugLineNum = 337;BA.debugLine="Dim cur As Cursor";
_cur = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 //BA.debugLineNum = 338;BA.debugLine="Dim col_e As Int";
_col_e = 0;
 //BA.debugLineNum = 339;BA.debugLine="Dim row As Int";
_row = 0;
 //BA.debugLineNum = 340;BA.debugLine="Dim bigtxt As StringBuilder";
_bigtxt = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 341;BA.debugLine="Dim Limit As Int";
_limit = 0;
 //BA.debugLineNum = 342;BA.debugLine="Dim today As String";
_today = "";
 //BA.debugLineNum = 343;BA.debugLine="Dim ts As Long";
_ts = 0L;
 //BA.debugLineNum = 344;BA.debugLine="DateTime.DateFormat = \"yyMMdd\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("yyMMdd");
 //BA.debugLineNum = 345;BA.debugLine="Dim date1 As Long";
_date1 = 0L;
 //BA.debugLineNum = 346;BA.debugLine="Dim date2 As Long";
_date2 = 0L;
 //BA.debugLineNum = 347;BA.debugLine="date1=DateTime.Now";
_date1 = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 348;BA.debugLine="date2=DateTime.DateParse(DateTime.date(date1))";
_date2 = anywheresoftware.b4a.keywords.Common.DateTime.DateParse(anywheresoftware.b4a.keywords.Common.DateTime.Date(_date1));
 //BA.debugLineNum = 349;BA.debugLine="today=DateTime.Date(date2)";
_today = anywheresoftware.b4a.keywords.Common.DateTime.Date(_date2);
 //BA.debugLineNum = 350;BA.debugLine="bigtxt.Initialize";
_bigtxt.Initialize();
 //BA.debugLineNum = 351;BA.debugLine="Dim clause As String";
_clause = "";
 //BA.debugLineNum = 352;BA.debugLine="clause=\" where timestamp > \" &date2";
_clause = " where timestamp > "+BA.NumberToString(_date2);
 //BA.debugLineNum = 354;BA.debugLine="cur = SQL1.ExecQuery(\"select * from \" & table & clause)";
_cur.setObject((android.database.Cursor)(_sql1.ExecQuery("select * from "+_table+_clause)));
 //BA.debugLineNum = 356;BA.debugLine="Limit = cur.RowCount";
_limit = _cur.getRowCount();
 //BA.debugLineNum = 357;BA.debugLine="cur.Position = 0";
_cur.setPosition((int)(0));
 //BA.debugLineNum = 358;BA.debugLine="Dim values(cur.ColumnCount) As String";
_values = new String[_cur.getColumnCount()];
java.util.Arrays.fill(_values,"");
 //BA.debugLineNum = 359;BA.debugLine="DateTime.DateFormat=\"yy/MM/dd\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("yy/MM/dd");
 //BA.debugLineNum = 360;BA.debugLine="DateTime.timeformat=\"HH:mm:ss\"";
anywheresoftware.b4a.keywords.Common.DateTime.setTimeFormat("HH:mm:ss");
 //BA.debugLineNum = 362;BA.debugLine="bigtxt.Append(\"Date\"  & TAB &\" Time\" &TAB)";
_bigtxt.Append("Date"+anywheresoftware.b4a.keywords.Common.TAB+" Time"+anywheresoftware.b4a.keywords.Common.TAB);
 //BA.debugLineNum = 363;BA.debugLine="For col_e = 1 To cur.ColumnCount - 1";
{
final double step297 = 1;
final double limit297 = (int)(_cur.getColumnCount()-1);
for (_col_e = (int)(1); (step297 > 0 && _col_e <= limit297) || (step297 < 0 && _col_e >= limit297); _col_e += step297) {
 //BA.debugLineNum = 364;BA.debugLine="values(col_e) = cur.GetColumnName(col_e).ToLowerCase";
_values[_col_e] = _cur.GetColumnName(_col_e).toLowerCase();
 //BA.debugLineNum = 365;BA.debugLine="bigtxt.Append(values(col_e) & TAB)";
_bigtxt.Append(_values[_col_e]+anywheresoftware.b4a.keywords.Common.TAB);
 }
};
 //BA.debugLineNum = 367;BA.debugLine="bigtxt.Append(CRLF)";
_bigtxt.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 //BA.debugLineNum = 369;BA.debugLine="For row = 0 To Limit - 1";
{
final double step302 = 1;
final double limit302 = (int)(_limit-1);
for (_row = (int)(0); (step302 > 0 && _row <= limit302) || (step302 < 0 && _row >= limit302); _row += step302) {
 //BA.debugLineNum = 370;BA.debugLine="cur.Position = row";
_cur.setPosition(_row);
 //BA.debugLineNum = 372;BA.debugLine="ts=cur.GetLong2(0)";
_ts = _cur.GetLong2((int)(0));
 //BA.debugLineNum = 373;BA.debugLine="bigtxt.Append(DateTime.date(ts) & TAB &DateTime.time(ts)& TAB)";
_bigtxt.Append(anywheresoftware.b4a.keywords.Common.DateTime.Date(_ts)+anywheresoftware.b4a.keywords.Common.TAB+anywheresoftware.b4a.keywords.Common.DateTime.Time(_ts)+anywheresoftware.b4a.keywords.Common.TAB);
 //BA.debugLineNum = 374;BA.debugLine="For col_e = 1 To cur.ColumnCount - 1";
{
final double step306 = 1;
final double limit306 = (int)(_cur.getColumnCount()-1);
for (_col_e = (int)(1); (step306 > 0 && _col_e <= limit306) || (step306 < 0 && _col_e >= limit306); _col_e += step306) {
 //BA.debugLineNum = 375;BA.debugLine="values(col_e) = cur.GetString2(col_e)";
_values[_col_e] = _cur.GetString2(_col_e);
 //BA.debugLineNum = 376;BA.debugLine="bigtxt.Append(values(col_e) & TAB)";
_bigtxt.Append(_values[_col_e]+anywheresoftware.b4a.keywords.Common.TAB);
 }
};
 //BA.debugLineNum = 378;BA.debugLine="bigtxt.Append(CRLF)";
_bigtxt.Append(anywheresoftware.b4a.keywords.Common.CRLF);
 }
};
 //BA.debugLineNum = 381;BA.debugLine="cur.Close";
_cur.Close();
 //BA.debugLineNum = 382;BA.debugLine="DateTime.DateFormat=\"yyMMdd\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("yyMMdd");
 //BA.debugLineNum = 383;BA.debugLine="File.writestring(DBFilePath, table&\"_\"&DateTime.date(DateTime.Now)&\".txt\",bigtxt)";
anywheresoftware.b4a.keywords.Common.File.WriteString(_dbfilepath,_table+"_"+anywheresoftware.b4a.keywords.Common.DateTime.Date(anywheresoftware.b4a.keywords.Common.DateTime.getNow())+".txt",String.valueOf(_bigtxt));
 //BA.debugLineNum = 384;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
scanner._process_globals();
charts._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 35;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 36;BA.debugLine="Dim Btn_connect As Button";
mostCurrent._btn_connect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Dim Btn_stop As Button";
mostCurrent._btn_stop = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Dim Lbl_connect As Label";
mostCurrent._lbl_connect = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 39;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 40;BA.debugLine="Dim j As Int";
_j = 0;
 //BA.debugLineNum = 42;BA.debugLine="Dim lbl_fps As Label";
mostCurrent._lbl_fps = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Dim whkm As Double";
_whkm = 0;
 //BA.debugLineNum = 46;BA.debugLine="Dim L_A As Label";
mostCurrent._l_a = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Dim L_auto As Label";
mostCurrent._l_auto = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 48;BA.debugLine="Dim l_ODO As Label";
mostCurrent._l_odo = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Dim l_speed As Label";
mostCurrent._l_speed = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 50;BA.debugLine="Dim L_V As Label";
mostCurrent._l_v = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 51;BA.debugLine="Dim l_w As Label";
mostCurrent._l_w = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 52;BA.debugLine="Dim lg_alt As Label";
mostCurrent._lg_alt = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 53;BA.debugLine="Dim lg_lat As Label";
mostCurrent._lg_lat = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 54;BA.debugLine="Dim lg_lon As Label";
mostCurrent._lg_lon = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 55;BA.debugLine="Dim lg_speed As Label";
mostCurrent._lg_speed = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 56;BA.debugLine="Dim Pnl_GPS As Panel";
mostCurrent._pnl_gps = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 57;BA.debugLine="Dim l_whkm As Label";
mostCurrent._l_whkm = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 58;BA.debugLine="Dim Pnl_graph As Panel";
mostCurrent._pnl_graph = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 59;BA.debugLine="Dim ctro As Int";
_ctro = 0;
 //BA.debugLineNum = 60;BA.debugLine="Dim todo(200) As Int";
_todo = new int[(int)(200)];
;
 //BA.debugLineNum = 61;BA.debugLine="Dim twpos(200) As Int";
_twpos = new int[(int)(200)];
;
 //BA.debugLineNum = 62;BA.debugLine="Dim twneg(200) As Int";
_twneg = new int[(int)(200)];
;
 //BA.debugLineNum = 63;BA.debugLine="Dim L_soc As Label";
mostCurrent._l_soc = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 64;BA.debugLine="Dim Pnl_trip As Panel";
mostCurrent._pnl_trip = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 65;BA.debugLine="Dim lbl_avgspeed As Label";
mostCurrent._lbl_avgspeed = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 66;BA.debugLine="Dim lbl_dist As Label";
mostCurrent._lbl_dist = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 67;BA.debugLine="Dim lbl_time As Label";
mostCurrent._lbl_time = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 68;BA.debugLine="Dim lbl_whi As Label";
mostCurrent._lbl_whi = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 69;BA.debugLine="Dim lbl_whkm As Label";
mostCurrent._lbl_whkm = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 70;BA.debugLine="Dim lbl_who As Label";
mostCurrent._lbl_who = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 71;BA.debugLine="Dim lbl_pc As Label";
mostCurrent._lbl_pc = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 72;BA.debugLine="Dim lbl_cor As Label";
mostCurrent._lbl_cor = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 73;BA.debugLine="Dim lalt As Label";
mostCurrent._lalt = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 74;BA.debugLine="Dim toggle_alt As Boolean";
_toggle_alt = false;
 //BA.debugLineNum = 75;BA.debugLine="End Sub";
return "";
}
public static int  _maketransparent(int _color,int _alpha) throws Exception{
 //BA.debugLineNum = 331;BA.debugLine="Sub MakeTransparent(Color As Int, Alpha As Int) As Int";
 //BA.debugLineNum = 332;BA.debugLine="Return Bit.And(Color, Bit.Or(0x00FFFFFF, Bit.ShiftLeft(Alpha, 24)))";
if (true) return anywheresoftware.b4a.keywords.Common.Bit.And(_color,anywheresoftware.b4a.keywords.Common.Bit.Or((int)(0x00ffffff),anywheresoftware.b4a.keywords.Common.Bit.ShiftLeft(_alpha,(int)(24))));
 //BA.debugLineNum = 333;BA.debugLine="End Sub";
return 0;
}
public static String  _pnl_batt_click() throws Exception{
anywheresoftware.b4a.agraham.reflection.Reflection _obj1 = null;
anywheresoftware.b4a.agraham.reflection.Reflection _obj2 = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper _c = null;
Object[] _args = null;
String[] _types = null;
anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper _out = null;
 //BA.debugLineNum = 413;BA.debugLine="Sub Pnl_batt_Click";
 //BA.debugLineNum = 414;BA.debugLine="DateTime.DateFormat=\"yyMMdd\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("yyMMdd");
 //BA.debugLineNum = 415;BA.debugLine="DateTime.timeformat=\"HHmmss\"";
anywheresoftware.b4a.keywords.Common.DateTime.setTimeFormat("HHmmss");
 //BA.debugLineNum = 416;BA.debugLine="Dim Obj1, Obj2 As Reflector";
_obj1 = new anywheresoftware.b4a.agraham.reflection.Reflection();
_obj2 = new anywheresoftware.b4a.agraham.reflection.Reflection();
 //BA.debugLineNum = 417;BA.debugLine="Dim bmp As Bitmap";
_bmp = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
 //BA.debugLineNum = 418;BA.debugLine="Dim c As Canvas";
_c = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
 //BA.debugLineNum = 419;BA.debugLine="Obj1.Target = Obj1.GetActivityBA";
_obj1.Target = (Object)(_obj1.GetActivityBA(processBA));
 //BA.debugLineNum = 420;BA.debugLine="Obj1.Target = Obj1.GetField(\"vg\")";
_obj1.Target = _obj1.GetField("vg");
 //BA.debugLineNum = 421;BA.debugLine="bmp.InitializeMutable(Activity.Width, Activity.Height)";
_bmp.InitializeMutable(mostCurrent._activity.getWidth(),mostCurrent._activity.getHeight());
 //BA.debugLineNum = 422;BA.debugLine="c.Initialize2(bmp)";
_c.Initialize2((android.graphics.Bitmap)(_bmp.getObject()));
 //BA.debugLineNum = 423;BA.debugLine="Dim args(1) As Object";
_args = new Object[(int)(1)];
{
int d0 = _args.length;
for (int i0 = 0;i0 < d0;i0++) {
_args[i0] = new Object();
}
}
;
 //BA.debugLineNum = 424;BA.debugLine="Dim types(1) As String";
_types = new String[(int)(1)];
java.util.Arrays.fill(_types,"");
 //BA.debugLineNum = 425;BA.debugLine="Obj2.Target = c";
_obj2.Target = (Object)(_c);
 //BA.debugLineNum = 426;BA.debugLine="Obj2.Target = Obj2.GetField(\"canvas\")";
_obj2.Target = _obj2.GetField("canvas");
 //BA.debugLineNum = 427;BA.debugLine="args(0) = Obj2.Target";
_args[(int)(0)] = _obj2.Target;
 //BA.debugLineNum = 428;BA.debugLine="types(0) = \"android.graphics.Canvas\"";
_types[(int)(0)] = "android.graphics.Canvas";
 //BA.debugLineNum = 429;BA.debugLine="Obj1.RunMethod4(\"draw\", args, types)";
_obj1.RunMethod4("draw",_args,_types);
 //BA.debugLineNum = 430;BA.debugLine="Dim Out As OutputStream";
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();
 //BA.debugLineNum = 431;BA.debugLine="Out = File.OpenOutput(DBFilePath, \"pict_\"&DateTime.date(DateTime.Now)&\"_\"&DateTime.time(DateTime.Now)& \".png\", False)";
_out = anywheresoftware.b4a.keywords.Common.File.OpenOutput(_dbfilepath,"pict_"+anywheresoftware.b4a.keywords.Common.DateTime.Date(anywheresoftware.b4a.keywords.Common.DateTime.getNow())+"_"+anywheresoftware.b4a.keywords.Common.DateTime.Time(anywheresoftware.b4a.keywords.Common.DateTime.getNow())+".png",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 432;BA.debugLine="bmp.WriteToStream(Out, 100, \"PNG\")";
_bmp.WriteToStream((java.io.OutputStream)(_out.getObject()),(int)(100),BA.getEnumFromString(android.graphics.Bitmap.CompressFormat.class,"PNG"));
 //BA.debugLineNum = 433;BA.debugLine="Out.Close";
_out.Close();
 //BA.debugLineNum = 435;BA.debugLine="End Sub";
return "";
}
public static String  _pnl_gps_click() throws Exception{
 //BA.debugLineNum = 405;BA.debugLine="Sub Pnl_GPS_Click";
 //BA.debugLineNum = 406;BA.debugLine="If lalt.Text=\"Alt\" Then";
if ((mostCurrent._lalt.getText()).equals("Alt")) { 
 //BA.debugLineNum = 407;BA.debugLine="lalt.Text=\"SoC\"";
mostCurrent._lalt.setText((Object)("SoC"));
 }else {
 //BA.debugLineNum = 410;BA.debugLine="lalt.Text=\"Alt\"";
mostCurrent._lalt.setText((Object)("Alt"));
 };
 //BA.debugLineNum = 412;BA.debugLine="End Sub";
return "";
}
public static String  _pnl_graph_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 395;BA.debugLine="Sub Pnl_graph_Touch (Action As Int, X As Float, Y As Float)";
 //BA.debugLineNum = 396;BA.debugLine="Pnl_trip.Visible=True";
mostCurrent._pnl_trip.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 397;BA.debugLine="Pnl_trip.Enabled=True";
mostCurrent._pnl_trip.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 398;BA.debugLine="Pnl_graph.Visible=False";
mostCurrent._pnl_graph.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 399;BA.debugLine="Pnl_graph.Enabled=False";
mostCurrent._pnl_graph.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 402;BA.debugLine="End Sub";
return "";
}
public static String  _pnl_trip_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 385;BA.debugLine="Sub Pnl_trip_Touch (Action As Int, X As Float, Y As Float)";
 //BA.debugLineNum = 386;BA.debugLine="Pnl_trip.Visible=False";
mostCurrent._pnl_trip.setVisible(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 387;BA.debugLine="Pnl_trip.Enabled=False";
mostCurrent._pnl_trip.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 389;BA.debugLine="Pnl_graph.Visible=True";
mostCurrent._pnl_graph.setVisible(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 390;BA.debugLine="Pnl_graph.Enabled=True";
mostCurrent._pnl_graph.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 391;BA.debugLine="If ctro > 1 Then";
if (_ctro>1) { 
 //BA.debugLineNum = 392;BA.debugLine="CreateStackedBarsTab";
_createstackedbarstab();
 };
 //BA.debugLineNum = 394;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim DBFilePath As String			: DBFilePath = File.DirRootExternal & \"/BT_CAN\"";
_dbfilepath = "";
 //BA.debugLineNum = 18;BA.debugLine="Dim DBFilePath As String			: DBFilePath = File.DirRootExternal & \"/BT_CAN\"";
_dbfilepath = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal()+"/BT_CAN";
 //BA.debugLineNum = 19;BA.debugLine="Dim DBFileName As String			: DBFileName = \"btcan.db\"";
_dbfilename = "";
 //BA.debugLineNum = 19;BA.debugLine="Dim DBFileName As String			: DBFileName = \"btcan.db\"";
_dbfilename = "btcan.db";
 //BA.debugLineNum = 20;BA.debugLine="Dim SQL1 As SQL";
_sql1 = new anywheresoftware.b4a.sql.SQL();
 //BA.debugLineNum = 23;BA.debugLine="Dim BT_Macadr As String			' the Mac Adress of the preferred BT interface";
_bt_macadr = "";
 //BA.debugLineNum = 25;BA.debugLine="Dim FpS As Int		' frame / sec will be used as a watchdog";
_fps = 0;
 //BA.debugLineNum = 26;BA.debugLine="Dim Admin As BluetoothAdmin";
_admin = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 27;BA.debugLine="Dim GPS1 As GPS";
_gps1 = new anywheresoftware.b4a.gps.GPS();
 //BA.debugLineNum = 28;BA.debugLine="Dim Phone2 As PhoneWakeState";
_phone2 = new anywheresoftware.b4a.phone.Phone.PhoneWakeState();
 //BA.debugLineNum = 29;BA.debugLine="Dim Serial1 As Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 30;BA.debugLine="Dim sb As StringBuilder";
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Dim DatHeur As Long";
_datheur = 0L;
 //BA.debugLineNum = 33;BA.debugLine="End Sub";
return "";
}
public static String  _refreshfast() throws Exception{
 //BA.debugLineNum = 224;BA.debugLine="Sub RefreshFast";
 //BA.debugLineNum = 226;BA.debugLine="l_speed.text = scanner.speed";
mostCurrent._l_speed.setText((Object)(mostCurrent._scanner._speed));
 //BA.debugLineNum = 227;BA.debugLine="L_A.text = NumberFormat2(scanner.b_Amp, 0, 1, 1, False)";
mostCurrent._l_a.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._b_amp,(int)(0),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.False)));
 //BA.debugLineNum = 228;BA.debugLine="L_V.text = NumberFormat2(scanner.b_volt, 0, 0, 0, False)";
mostCurrent._l_v.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._b_volt,(int)(0),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.False)));
 //BA.debugLineNum = 229;BA.debugLine="If scanner.B_W > 9999 OR scanner.B_W < -9999 Then";
if (mostCurrent._scanner._b_w>9999 || mostCurrent._scanner._b_w<-9999) { 
 //BA.debugLineNum = 230;BA.debugLine="l_w.text = NumberFormat2(scanner.b_w /1000, 1, 1, 1, False) & \" KW\"";
mostCurrent._l_w.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._b_w/(double)1000,(int)(1),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.False)+" KW"));
 }else {
 //BA.debugLineNum = 232;BA.debugLine="l_w.text = NumberFormat2(scanner.b_w, 0, 0, 0, True)";
mostCurrent._l_w.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._b_w,(int)(0),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.True)));
 };
 //BA.debugLineNum = 234;BA.debugLine="whkm = scanner.b_w / scanner.Speed";
_whkm = mostCurrent._scanner._b_w/(double)mostCurrent._scanner._speed;
 //BA.debugLineNum = 235;BA.debugLine="l_whkm.text = NumberFormat2(whkm, 0, 0, 0, False)";
mostCurrent._l_whkm.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(_whkm,(int)(0),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.False)));
 //BA.debugLineNum = 236;BA.debugLine="lg_speed.text = NumberFormat(scanner.Gps_speed, 0, 1)";
mostCurrent._lg_speed.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat(mostCurrent._scanner._gps_speed,(int)(0),(int)(1))));
 //BA.debugLineNum = 237;BA.debugLine="End Sub";
return "";
}
public static String  _refreshgps() throws Exception{
 //BA.debugLineNum = 287;BA.debugLine="Sub Refreshgps";
 //BA.debugLineNum = 288;BA.debugLine="lg_lat.text = scanner.Gps_Lat";
mostCurrent._lg_lat.setText((Object)(mostCurrent._scanner._gps_lat));
 //BA.debugLineNum = 289;BA.debugLine="lg_lon.text = scanner.Gps_Lon";
mostCurrent._lg_lon.setText((Object)(mostCurrent._scanner._gps_lon));
 //BA.debugLineNum = 290;BA.debugLine="lg_speed.text = NumberFormat(scanner.Gps_speed, 0, 1)";
mostCurrent._lg_speed.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat(mostCurrent._scanner._gps_speed,(int)(0),(int)(1))));
 //BA.debugLineNum = 291;BA.debugLine="If lalt.Text=\"Alt\" Then";
if ((mostCurrent._lalt.getText()).equals("Alt")) { 
 //BA.debugLineNum = 292;BA.debugLine="lg_alt.text = scanner.Gps_alt";
mostCurrent._lg_alt.setText((Object)(mostCurrent._scanner._gps_alt));
 }else {
 //BA.debugLineNum = 294;BA.debugLine="lalt.Text=NumberFormat2(scanner.b_soc, 2, 1, 1, False)";
mostCurrent._lalt.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._b_soc,(int)(2),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.False)));
 };
 //BA.debugLineNum = 297;BA.debugLine="End Sub";
return "";
}
public static String  _refreshodo() throws Exception{
long _ts = 0L;
 //BA.debugLineNum = 239;BA.debugLine="Sub RefreshOdo";
 //BA.debugLineNum = 241;BA.debugLine="l_ODO.text = scanner.odo";
mostCurrent._l_odo.setText((Object)(mostCurrent._scanner._odo));
 //BA.debugLineNum = 242;BA.debugLine="If scanner.Odo > todo(ctro) Then";
if (mostCurrent._scanner._odo>_todo[_ctro]) { 
 //BA.debugLineNum = 243;BA.debugLine="ctro = ctro + 1";
_ctro = (int)(_ctro+1);
 //BA.debugLineNum = 244;BA.debugLine="todo(ctro) = scanner.Odo";
_todo[_ctro] = mostCurrent._scanner._odo;
 //BA.debugLineNum = 245;BA.debugLine="twpos(ctro) = scanner.I_vakm_pos * - 1";
_twpos[_ctro] = (int)(mostCurrent._scanner._i_vakm_pos*-1);
 //BA.debugLineNum = 246;BA.debugLine="twneg(ctro) = scanner.I_vakm_neg * - 1";
_twneg[_ctro] = (int)(mostCurrent._scanner._i_vakm_neg*-1);
 //BA.debugLineNum = 247;BA.debugLine="Dim ts As Long : ts=DateTime.Now";
_ts = 0L;
 //BA.debugLineNum = 247;BA.debugLine="Dim ts As Long : ts=DateTime.Now";
_ts = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 248;BA.debugLine="SQL1.ExecNonQuery(\"INSERT INTO ODOLOG VALUES(\" &ts &\",\" &scanner.odo &\",\"& scanner.b_soc &\",\" &scanner.km_nbs &\",\" &scanner.I_vakm_pos &\",\" &scanner.I_vakm_neg &\",\" &scanner.autonomie &\",'\" &scanner.gps_lat &\"','\" &scanner.gps_lon &\"',\" &scanner.gps_speed &\",\" &scanner.gps_alt &\",\" &scanner.mB  &\")\")";
_sql1.ExecNonQuery("INSERT INTO ODOLOG VALUES("+BA.NumberToString(_ts)+","+BA.NumberToString(mostCurrent._scanner._odo)+","+BA.NumberToString(mostCurrent._scanner._b_soc)+","+BA.NumberToString(mostCurrent._scanner._km_nbs)+","+BA.NumberToString(mostCurrent._scanner._i_vakm_pos)+","+BA.NumberToString(mostCurrent._scanner._i_vakm_neg)+","+BA.NumberToString(mostCurrent._scanner._autonomie)+",'"+mostCurrent._scanner._gps_lat+"','"+mostCurrent._scanner._gps_lon+"',"+BA.NumberToString(mostCurrent._scanner._gps_speed)+","+BA.NumberToString(mostCurrent._scanner._gps_alt)+","+BA.NumberToString(mostCurrent._scanner._mb)+")");
 };
 //BA.debugLineNum = 251;BA.debugLine="If ctro > 1 Then";
if (_ctro>1) { 
 //BA.debugLineNum = 252;BA.debugLine="If Pnl_graph.Visible=True Then";
if (mostCurrent._pnl_graph.getVisible()==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 253;BA.debugLine="CreateStackedBarsTab";
_createstackedbarstab();
 };
 };
 //BA.debugLineNum = 256;BA.debugLine="End Sub";
return "";
}
public static String  _refreshsec() throws Exception{
long _ts = 0L;
 //BA.debugLineNum = 258;BA.debugLine="Sub RefreshSec";
 //BA.debugLineNum = 261;BA.debugLine="lbl_fps.text = scanner.FpS";
mostCurrent._lbl_fps.setText((Object)(mostCurrent._scanner._fps));
 //BA.debugLineNum = 262;BA.debugLine="L_soc.text = NumberFormat2(scanner.b_soc, 2, 1, 1, False)";
mostCurrent._l_soc.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._b_soc,(int)(2),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.False)));
 //BA.debugLineNum = 263;BA.debugLine="L_auto.text = scanner.autonomie";
mostCurrent._l_auto.setText((Object)(mostCurrent._scanner._autonomie));
 //BA.debugLineNum = 264;BA.debugLine="l_ODO.text = scanner.odo";
mostCurrent._l_odo.setText((Object)(mostCurrent._scanner._odo));
 //BA.debugLineNum = 265;BA.debugLine="If scanner.FpS < 1 Then";
if (mostCurrent._scanner._fps<1) { 
 };
 //BA.debugLineNum = 270;BA.debugLine="Dim ts As Long : ts=DateTime.Now";
_ts = 0L;
 //BA.debugLineNum = 270;BA.debugLine="Dim ts As Long : ts=DateTime.Now";
_ts = anywheresoftware.b4a.keywords.Common.DateTime.getNow();
 //BA.debugLineNum = 271;BA.debugLine="If scanner.FpS > 90 Then";
if (mostCurrent._scanner._fps>90) { 
 //BA.debugLineNum = 272;BA.debugLine="SQL1.ExecNonQuery(\"INSERT INTO SECLOG VALUES(\" &ts &\",\" &scanner.FpS &\",\" &scanner.odo &\",\" &scanner.Speed &\",\" &scanner.B_volt&\",\" &scanner.B_amp&\",\" &scanner.b_soc &\",\" &scanner.autonomie &\",'\" &scanner.gps_lat &\"','\"& scanner.gps_lon &\"',\"& scanner.gps_speed &\",\"& scanner.gps_alt &\",\"& scanner.mb  &\")\")";
_sql1.ExecNonQuery("INSERT INTO SECLOG VALUES("+BA.NumberToString(_ts)+","+BA.NumberToString(mostCurrent._scanner._fps)+","+BA.NumberToString(mostCurrent._scanner._odo)+","+BA.NumberToString(mostCurrent._scanner._speed)+","+BA.NumberToString(mostCurrent._scanner._b_volt)+","+BA.NumberToString(mostCurrent._scanner._b_amp)+","+BA.NumberToString(mostCurrent._scanner._b_soc)+","+BA.NumberToString(mostCurrent._scanner._autonomie)+",'"+mostCurrent._scanner._gps_lat+"','"+mostCurrent._scanner._gps_lon+"',"+BA.NumberToString(mostCurrent._scanner._gps_speed)+","+BA.NumberToString(mostCurrent._scanner._gps_alt)+","+BA.NumberToString(mostCurrent._scanner._mb)+")");
 };
 //BA.debugLineNum = 275;BA.debugLine="If Pnl_trip.Visible=True Then";
if (mostCurrent._pnl_trip.getVisible()==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 276;BA.debugLine="lbl_time.text=ConvertToTimeFormat(scanner.Trip_nbs)";
mostCurrent._lbl_time.setText((Object)(_converttotimeformat(mostCurrent._scanner._trip_nbs)));
 //BA.debugLineNum = 277;BA.debugLine="lbl_dist.text=NumberFormat2(scanner.Trip_dist / 1000 ,0,2,2,False)";
mostCurrent._lbl_dist.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._trip_dist/(double)1000,(int)(0),(int)(2),(int)(2),anywheresoftware.b4a.keywords.Common.False)));
 //BA.debugLineNum = 278;BA.debugLine="lbl_who.text=NumberFormat2(scanner.S_vaTrip_neg/360000,1,0,0,True)";
mostCurrent._lbl_who.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._s_vatrip_neg/(double)360000,(int)(1),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.True)));
 //BA.debugLineNum = 279;BA.debugLine="lbl_whi.text=NumberFormat2(scanner.S_vaTrip_pos/360000,1,0,0,True)";
mostCurrent._lbl_whi.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2(mostCurrent._scanner._s_vatrip_pos/(double)360000,(int)(1),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.True)));
 //BA.debugLineNum = 280;BA.debugLine="lbl_pc.text=NumberFormat2((scanner.S_vaTrip_pos/scanner.S_vaTrip_neg)*-100,0,0,0,False) &\" %\"";
mostCurrent._lbl_pc.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2((mostCurrent._scanner._s_vatrip_pos/(double)mostCurrent._scanner._s_vatrip_neg)*-100,(int)(0),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.False)+" %"));
 //BA.debugLineNum = 281;BA.debugLine="lbl_avgspeed.text=NumberFormat2((scanner.Trip_dist/1000)/(scanner.Trip_nbs/3600),0,1,1,False)";
mostCurrent._lbl_avgspeed.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2((mostCurrent._scanner._trip_dist/(double)1000)/(double)(mostCurrent._scanner._trip_nbs/(double)3600),(int)(0),(int)(1),(int)(1),anywheresoftware.b4a.keywords.Common.False)));
 //BA.debugLineNum = 282;BA.debugLine="lbl_whkm.text=NumberFormat2((scanner.S_vaTrip_neg/360000 + scanner.S_vaTrip_pos/360000)/(scanner.Trip_dist / 1000),0,0,0,False)";
mostCurrent._lbl_whkm.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2((mostCurrent._scanner._s_vatrip_neg/(double)360000+mostCurrent._scanner._s_vatrip_pos/(double)360000)/(double)(mostCurrent._scanner._trip_dist/(double)1000),(int)(0),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.False)));
 //BA.debugLineNum = 283;BA.debugLine="lbl_cor.text=NumberFormat2((scanner.dist_coef/36),2,3,3,False)";
mostCurrent._lbl_cor.setText((Object)(anywheresoftware.b4a.keywords.Common.NumberFormat2((mostCurrent._scanner._dist_coef/(double)36),(int)(2),(int)(3),(int)(3),anywheresoftware.b4a.keywords.Common.False)));
 };
 //BA.debugLineNum = 285;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 184;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
 //BA.debugLineNum = 185;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 186;BA.debugLine="ToastMessageShow(\"Connected successfully\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Connected successfully",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 188;BA.debugLine="SQL1.ExecNonQuery(\"DELETE FROM MACADR\")";
_sql1.ExecNonQuery("DELETE FROM MACADR");
 //BA.debugLineNum = 189;BA.debugLine="SQL1.ExecNonQuery(\"INSERT INTO MACADR VALUES('\" &BT_Macadr &\"')\")";
_sql1.ExecNonQuery("INSERT INTO MACADR VALUES('"+_bt_macadr+"')");
 //BA.debugLineNum = 192;BA.debugLine="StartService(scanner)";
anywheresoftware.b4a.keywords.Common.StartService(mostCurrent.activityBA,(Object)(mostCurrent._scanner.getObject()));
 //BA.debugLineNum = 193;BA.debugLine="Lbl_connect.Color = Colors.yellow";
mostCurrent._lbl_connect.setColor(anywheresoftware.b4a.keywords.Common.Colors.Yellow);
 //BA.debugLineNum = 194;BA.debugLine="Lbl_connect.text = \"1 service started\"";
mostCurrent._lbl_connect.setText((Object)("1 service started"));
 }else {
 //BA.debugLineNum = 196;BA.debugLine="Lbl_connect.Color = Colors.Red";
mostCurrent._lbl_connect.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 197;BA.debugLine="Lbl_connect.text = \"0 Not Connected\"";
mostCurrent._lbl_connect.setText((Object)("0 Not Connected"));
 };
 //BA.debugLineNum = 200;BA.debugLine="End Sub";
return "";
}
public static String  _showconnectsts() throws Exception{
 //BA.debugLineNum = 213;BA.debugLine="Sub ShowConnectSts";
 //BA.debugLineNum = 214;BA.debugLine="Lbl_connect.text = scanner.msg1";
mostCurrent._lbl_connect.setText((Object)(mostCurrent._scanner._msg1));
 //BA.debugLineNum = 215;BA.debugLine="If scanner.connected = True Then";
if (mostCurrent._scanner._connected==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 216;BA.debugLine="Lbl_connect.Color = Colors.Green";
mostCurrent._lbl_connect.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 }else {
 //BA.debugLineNum = 219;BA.debugLine="Lbl_connect.Color = Colors.Yellow";
mostCurrent._lbl_connect.setColor(anywheresoftware.b4a.keywords.Common.Colors.Yellow);
 };
 //BA.debugLineNum = 222;BA.debugLine="End Sub";
return "";
}
}
